#include <process.h>
#include <sys/uio.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/neutrino.h>
#include <spawn.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>

int VG_coid;

static pthread_key_t color_key;

int GetColor ()
  {
  return ((int)pthread_getspecific (color_key) - 1) & 0xFFFFFF;
  }

void SetColor (int color)
  {
  pthread_setspecific (color_key, (void*)((color + 1) & 0xFFFFFF));
  }

static bool spawned = false;

int ConnectGraph (const char *name) 
  {
  int i, fd, pid, chid, t, flag = 0;
  char file [32];
  strcpy (file, "/dev/shmem/vg-");
  if (name == 0) name = "VG";
  strncat (file, name, 13);
  fd = open (file, O_RDONLY);
  if (fd >= 0)
    {
    read (fd, &pid, 4), read (fd, &chid, 4), read (fd, &t, 4);
    if ((time(0) - t) <= 1) 
      {
      VG_coid = ConnectAttach (0, pid, chid, 0, 0);
      if (VG_coid < 0)
        {
        perror ("connect vg");
        return -1;
        }
      pthread_key_create (&color_key, 0);
      return 0;
      }
    else close (fd), unlink (file);
    }
  pid = spawnlpe (P_WAIT, "vg", "vg", "-n", name, 0, environ);
  if (pid < 0)
    {
    perror ("spawn");
    return -1;
    }
  spawned = true;
  i = 10;
  while (i)
    {
    fd = open (file, O_RDONLY);
    if (fd >= 0) break;
    delay (100);
    i--;
    }
  if (fd < 0)
    {
    perror ("open vg");
    return -1;
    }
  read (fd, &pid, 4), read (fd, &chid, 4);
  VG_coid = ConnectAttach (0, pid, chid, 0, 0);
  if (VG_coid < 0)
    {
    perror ("connect vg");
    return -1;
    }
  pthread_key_create (&color_key, 0);
  return 0;
  }

void CloseGraph ()
  {
  if (spawned) MsgSendPulse (VG_coid, 10, 0, 0);
  ConnectDetach (VG_coid);
  }

