#define CREATE 100
// subtypes for CREATE
#define PIXEL    0
#define LINE     1
#define POLYLINE 2
#define POLYGON  3
#define RECT     4
#define ELLIPSE  5
#define ARC      6
#define GRID     7
#define TEXT     8
#define GROUP    9
#define OSC     10
#define IMAGE24   11
#define IMAGE32   12
#define IMAGE24SM 13
#define IMAGE32SM 14

#define CHANGE 200
// subtypes for CHANGE
#define COLOR     0
#define FILL      1
#define MOVETO    2
#define MOVE      3
#define ENLARGETO 4
#define ENLARGE   5
#define LINEWIDTH 6
#define CHTEXT    7

#define GETRES 300
// subtypes for GETRES
#define GETCOLOR 0
#define GETFILL  1
#define GETPOS   2
#define GETDIM   3

#define MANAGE 400
// subtypes for MANAGE
#define REALIZE   0
#define UNREALIZE 1
#define DELETE    2
#define CLEAR     3

#define INPUT 500


extern int VG_coid;

struct tMsg
  {
  short int type;
  short int subtype;
  int parent;
  };
  
struct tPoint
  {
  short int x, y;
  };

struct tColorMsg : tMsg
  {
  int color;
  };

struct tPointMsg : tMsg
  {
  tPoint p;
  };


struct tPixelMsg : tColorMsg
  {
  tPoint p;
  };

struct tLineMsg : tColorMsg
  {
  tPoint p1, p2;
  };

struct tPolyMsg : tColorMsg
  {
  int pnum;
  tPoint p [];
  };

struct tRectMsg : tColorMsg
  {
  int roundness;
  tPoint p1, p2;
  };

struct tTextMsg : tPixelMsg
  {
  char str [];
  };

struct tGridMsg : tLineMsg
  {
  int nrows, ncols;
  };

struct tArcMsg : tLineMsg
  {
  int sangle, eangle, arctype;
  };

struct tImageMsg : tMsg
  {
  tPoint p1, p2;
  };

struct tImageSM
  {
  char name [12];
  int fd;
  short int w, h;
  char data [];
  };

struct tImageSMMsg : tPointMsg, tImageSM
  {
  };
