#include <sys/neutrino.h>
#include "def.h"

void EnlargeTo (const tPoint points [], int npoints, int parent)
  {
  tPolyMsg msg;
  iov_t Msg [2];
  
  msg.type = CHANGE;
  msg.subtype = ENLARGETO;
  msg.parent = parent;
  msg.pnum = npoints;

  Msg[0].iov_base = &msg;
  Msg[0].iov_len = sizeof(tPolyMsg);
  Msg[1].iov_base = (void*)points;
  Msg[1].iov_len = npoints * sizeof(tPoint);
  
  MsgSendvs (VG_coid, Msg, 2, 0, 0);
  }

void EnlargeTo (int x, int y, int w, int h, int parent)
  {
  tRectMsg msg;
  
  msg.type = CHANGE;
  msg.subtype = ENLARGETO;
  msg.parent = parent;
  msg.roundness = 2;
  msg.p1.x = x;
  msg.p1.y = y;
  msg.p2.x = x + w;
  msg.p2.y = y + h;
  MsgSend (VG_coid, &msg, sizeof(msg), 0, 0);
  }
