#include <sys/neutrino.h>
#include <unistd.h>
#include "def.h"

int Image32 (int x, int y, int w, int h, const void *im, int parent)
  {
  tImageMsg msg;
  iov_t siov [2];
  int ident, snd;
  
  msg.type = CREATE;
  msg.subtype = IMAGE32;
  msg.parent = parent;
  msg.p1.x = x;
  msg.p1.y = y;
  msg.p2.x = w;
  msg.p2.y = h;
  SETIOV (siov, &msg, sizeof(msg));
  SETIOV (siov+1, im, w * h * 4);

  snd = MsgSendvs (VG_coid, siov, 2, &ident, 4);
  if (snd < 0) return -1;
  else return ident;
  }

int Image24 (int x, int y, int w, int h, const void *im, int parent)
  {
  tImageMsg msg;
  iov_t siov [2];
  int ident, snd;
  
  msg.type = CREATE;
  msg.subtype = IMAGE24;
  msg.parent = parent;
  msg.p1.x = x;
  msg.p1.y = y;
  msg.p2.x = w;
  msg.p2.y = h;
  SETIOV (siov, &msg, sizeof(msg));
  SETIOV (siov+1, im, w * h * 3);

  snd = MsgSendvs (VG_coid, siov, 2, &ident, 4);
  if (snd < 0) return -1;
  else return ident;
  }

