#include <sys/neutrino.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <string.h>
#include "def.h"

void* ImageContainer (int w, int h)
  {
  tImageSM head, *p;
  int s, n;

  n = ClockCycles ();
  sprintf (head.name, "vg%x", n);
  head.fd = shm_open (head.name, O_CREAT+O_EXCL+O_RDWR, 0666);
    if (head.fd < 0) return 0;
  head.w = w, head.h = h;
  s = sizeof head + (w * h * 4);
  n = ftruncate (head.fd, s);
    if (n < 0) return 0;
  p = (tImageSM*) mmap (0, s, PROT_READ | PROT_WRITE, MAP_SHARED, head.fd, 0);
  if (p  == MAP_FAILED) return 0;
  memcpy (p, &head, sizeof head);
  return p->data;
  }

int Image (int x, int y, const void *imcont, int parent)
  {
  tImageSMMsg msg;
  int ident, snd;
  
  msg.type = CREATE;
  msg.subtype = IMAGESM;
  msg.parent = parent;
  msg.p.x = x;
  msg.p.y = y;
  memcpy (msg.name, (char*)imcont - sizeof(tImageSM), sizeof(tImageSM));

  snd = MsgSend (VG_coid, &msg, sizeof msg, &ident, 4);
  if (snd < 0) return -1;
  else return ident;
  }

